import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Player ߻ϴ Bullet.
 * 
 * @author 
 * @version 0.9
 */
public class Bullet  extends Actor
{
    /**
     * Act - do whatever the Bullet wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    final static double GRAV=40;
    final static int LIMITTIME=700;
    
    private double x,y;
    private double dx,dy;
    
    private int timeLeft;
    private boolean isExploded;
    private Player firedFrom;
    private GreenfootImage bulletImage=new GreenfootImage("bullet.png");
    private GreenfootImage dummyImage=new GreenfootImage("dummy.png");
    
    /**
     * Bullet  x,yǥ, power, ̵, ߻ Player Է¹޾ Bullet Ѵ.
     */
    public Bullet(double x, double y, double power, int rotation, Player firedFrom){
        this.x=x;
        this.y=y;
        this.timeLeft=LIMITTIME;
        power/=10;
        dx=power*Math.cos(Math.toRadians(rotation));
        dy=power*Math.sin(Math.toRadians(rotation));
        this.firedFrom=firedFrom;
    }
    
    public void act() 
    {
        if(timeLeft==0){
            if(isExploded==false){
                Greenfoot.playSound("timeout.wav");
            }
            
            Space space=(Space)getWorld();
            space.bigSpaceOff();
            space.removeObject(this);
            space.getSelector().letNextPlayer();
            return;
        }
        --timeLeft;
        
        int limit=((Space)getWorld()).getPlanetN();
        for(int i=0;i<limit;i++){
            Planet planet=((Space)getWorld()).getPlanetList()[i];
            if(planet.isIn==true){
                getVector(planet);
            }
        }
        move();
        checkOut();
    }
        
    /**
     * Bullet Space   ȮѴ.
     *   쿡 BigSpace̹ Ѱ,
     * ġ ָ  쿡 Bullet ش.
     */
    private void checkOut(){
        Space space=(Space)getWorld();
        if(x<0 || x>space.WIDTH || y<0 || y>space.HEIGHT){
            setImage(dummyImage);
            space.bigSpaceOn(x,y);
        }
        else{
            setImage(bulletImage);
            space.bigSpaceOff();
        }
        
        if(x<-space.WIDTH || x>space.WIDTH*2 || y<-space.HEIGHT || y>space.HEIGHT*2){
            timeLeft=0;
            setImage(bulletImage);
            space.bigSpaceOff();
        }
        
    }
    
    /**
     *  ߷° Ͽ Bullet ̵Ų.
     */
    private void move(){
        x+=dx;
        y+=dy;
        setLocation((int)x,(int)y);
    }
    
    /**
     * Planet Ű ޾Ƽ  Planet Ÿ Ѵ.
     */
    private double distance(Planet planet){
        return Math.sqrt((planet.getX()-x)*(planet.getX()-x)+(planet.getY()-y)*(planet.getY()-y));
    }
    
    /**
     * Bullet ߻ Player ȯѴ.
     */
    public Player getFiredFrom(){
        return firedFrom;
    }
        
    /**
     * Planet Ű ޾  Planet  ߷º͸  dx,dy ش.
     */
    private void getVector(Planet planet){
        double dis=distance(planet);
        double m=planet.getDoubleM();
        dx+=getVectorX(m,planet.getX()-x,dis);
        dy+=getVectorY(m,planet.getY()-y,dis);
    }
    
    /**
     * Planet , x , Ÿ̸ ̿Ͽ ߷ x  Ѵ.
     */
    private double getVectorX(double mass, double gapX, double distance){
        return (GRAV*mass/(distance*distance))*gapX/distance;
    }
    
    /**
     * Planet , y , Ÿ̸ ̿Ͽ ߷ y  Ѵ.
     */
    private double getVectorY(double mass, double gapY, double distance){
        return (GRAV*mass/(distance*distance))*gapY/distance;
    }
    
    /**
     * Bullet  ӽð ȯѴ.
     */
    public int getTimeLeft(){
        return timeLeft;
    }
    
    /**
     * Bullet ĵǾ(ð ʰǾ) ȯѴ.
     */
    public boolean getIsExploded(){
        return isExploded;
    }
    
    /**
     * Bullet double x ȯѴ.
     */
    public double getBulletX(){
        return x;
    }
    
    /**
     * Bullet double y ȯѴ.
     */
    public double getBulletY(){
        return y;
    }
    
    /**
     * Bullet ߵ  óѴ.
     */
    public void setExploded(){
        timeLeft=0;
        isExploded=true;
        Space space=(Space)getWorld();
        space.addObject(new Explosion(),(int)x,(int)y);
    }
}
