import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;

/**
 * SpaceShot Space Ѵ.
 * 
 * @author 
 * @version 0.9
 */
public class Space  extends World
{    
    static final int WIDTH=600;
    static final int HEIGHT=560;
    
    
    private int planetN;
    private int playerN=3;
    private boolean replay=true;
    private Selector selector;
    private Bullet bullet;
    private Planet[] planetList;
    private Dummy dummy=new Dummy();
    private GreenfootImage[] planetImage;
    private GreenfootImage bigSpaceDefault;
    private GreenfootImage bigSpace;
    private GreenfootImage bulletImage=new GreenfootImage("bullet.png");
 
    private Replay rep;
    
    /**
     * Space Ѵ.
     */
    public Space()
    {
        super(WIDTH, HEIGHT, 1);
        set();
    }
    
    /**
     * World غ ϷѴ.
     */
    private void set(){
        setPaintOrder(ScoreBoard.class,Selector.class,Dummy.class,Explosion.class,Arrow.class,Player.class,Planet.class,Bullet.class);
        bulletImage.scale(15,15);       
        
        selector=new Selector(setPlayer(playerN),playerN);
        addObject(selector,200,10);
        
        planetImage=new GreenfootImage[7];
        setPlanetImage();
        planetN=Greenfoot.getRandomNumber(3)+2;
        setPlanet(planetN);
        
        setBigSpaceDefault();
        addObject(dummy,WIDTH/2,HEIGHT/2);
    }
    
    /**
     * ⺻ ȭ 3 Ȯ ȭ Ѵ.
     */
    private void setBigSpaceDefault(){
        bigSpaceDefault=new GreenfootImage(WIDTH,HEIGHT);
        bigSpaceDefault.setColor(Color.BLACK);
        bigSpaceDefault.fillRect(0,0,WIDTH,HEIGHT);
        bigSpaceDefault.setTransparency(230);
        for(int i=0;i<10;i++){
            bigSpaceDefault.drawRect(i,i,WIDTH-i*2,HEIGHT-i*2);
        }
        bigSpaceDefault.setColor(Color.BLUE);
        bigSpaceDefault.drawRect(WIDTH/3,HEIGHT/3,WIDTH/3,HEIGHT/3);
    }
    
    
    /**
     * dummyü bigSpace̹ ϰ,
     * bullet ġ x,y ŷ Է¹޾  ̹ Ͽ  ̹ ǥѴ.
     */
    public void bigSpaceOn(double x,double y){
        bigSpace=new GreenfootImage(bigSpaceDefault);
        bigSpace.drawImage(bulletImage,(int)((x+WIDTH)/3-2),(int)((y+HEIGHT)/3-2));
        dummy.setImage(bigSpace);
    }
    
    /**
     * Ȱȭ bigSpace̹ ȰȭŲ.(bigSpace ǥø .)
     */
    public void bigSpaceOff(){
        bigSpace=new GreenfootImage(1,1);
        dummy.setImage(bigSpace);
    }
    
    /**
     *     ScoreBoard ǥϰ,  .
     */
    public void finished(int winner){
        addObject(new ScoreBoard(winner,selector.getPlayer()[winner].getScore()),WIDTH/2,HEIGHT/2);
        Greenfoot.stop();
    }
    
    /**
     *  bullet x,y, power, ̵, bullet  Player Ű ޾Ƽ
     * bullet ϰ, ̸ world Ѵ.
     */
    public void makeBullet(double x, double y, int power, int rotation, Player firedFrom){
        bullet=new Bullet(x,y,power,rotation,firedFrom);
        Greenfoot.playSound("launch.wav");
        addObject(bullet,(int)x,(int)y);
    }
    
    /**
     * 浹 CanBeCollidedü Ű ޾
     * bullet ĽŰ, 浹 CanBeCollidedü ĸ޼带 ȣѴ.
     *  CanBeCollidedü Playerü  selector Player ޼带 ȣѴ.
     * ׸ bullet  Player  ȭŲ.
     */
    public void objectCollision(CanBeCollided object){
        bullet.setExploded();
        Greenfoot.playSound("explode.wav");
        if(object instanceof Player){
            if(replay==true){
                bullet.getFiredFrom().reShot();
                
                Greenfoot.setSpeed(40);
                rep=new Replay();
                addObject(rep,WIDTH/2,HEIGHT/2);
                replay=false;
            }
            else{
                selector.decreasePlayerN();
                object.explosion();
                bullet.getFiredFrom().changeScore(object);
                
                Greenfoot.setSpeed(50);
                removeObject(rep);
                replay=true;
            }
        }
        else{
            object.explosion();
            bullet.getFiredFrom().changeScore(object);
        }
            
    }
    
    /**
     * PlanetImage ȣ Ű ޾Ƽ,
     * Ǿִ PlanetImage迭κ ̿ شϴ ̹ ȯѴ.
     */
    public GreenfootImage getGreenfootImage(int n){
        return planetImage[n];
    }
    
    /**
     * selectorü ȯѴ.
     */
    public Selector getSelector(){
        return selector;
    }
    
    /**
     * planetListü ȯѴ.
     */
    public Planet[] getPlanetList(){
        return planetList;
    }
    
    /**
     * bulletü ȯѴ.
     */
    public Bullet getBullet(){
        return bullet;
    }
    
    /**
     *  Planet  ȯѴ.
     */
    public int getPlanetN(){
        return planetN;
    }
    
    /**
     * Player  ȯѴ.
     */
    public int getPlayerN(){
        return playerN;
    }
    
    /**
     * planetImage迭  Ǵ ̹ ־ش.
     */
    private void setPlanetImage(){
        planetImage[0]=new GreenfootImage("planet1.png");
        planetImage[1]=new GreenfootImage("planet2.png");
        planetImage[2]=new GreenfootImage("planet3.png");
        planetImage[3]=new GreenfootImage("planet4.png");
        planetImage[4]=new GreenfootImage("planet5.png");
        planetImage[5]=new GreenfootImage("planet6.png");
        planetImage[6]=new GreenfootImage("planet7.png");
    }
    
    /**
     *  Player  Ű ޾  ŭ Player World׵θ
     *  浹 ʴ  ҿ ġѴ.
     */
    private Player[] setPlayer(int n){
        Player[] player=new Player[n];
        for(int i=0;i<n;i++){
            if(Math.random()<0.5){
                player[i]=new Player(Math.random()*WIDTH,
                                     (Math.random()*(HEIGHT*2/5)+(HEIGHT*4/5))%HEIGHT);
            }
            else{
                player[i]=new Player((Math.random()*(WIDTH*2/5)+(WIDTH*4/5))%WIDTH,
                                     Math.random()*HEIGHT);
            }
            addObject(player[i],(int)player[i].getDoubleX(),(int)player[i].getDoubleY());
            if(player[i].checkOverlay()!=null){
                removeObject(player[i]);
                --i;
            }
        }
        return player;
    }
    
    /**
     *  Planet  Ű ޾  ŭ Planet World߾ӿ
     *  浹 ʴ  ҿ ġѴ.
     */
    private void setPlanet(int n){
        planetList=new Planet[n];
        for(int i=0;i<n;i++){
            planetList[i]=new Planet(Math.random()*(WIDTH*3/5)+(WIDTH/5),Math.random()*(HEIGHT*3/5)+(HEIGHT/5),Math.random()*200+50,this);
            addObject(planetList[i],(int)planetList[i].getDoubleX(),(int)planetList[i].getDoubleY());
            if(planetList[i].checkOverlay()!=null){
                removeObject(planetList[i]);
                --i;
            }
        }
    }
    
    public boolean getReplay(){
        return replay;
    }
}
